#include <bits/stdc++.h>

using namespace std;

using ll = int_fast64_t;

#define len(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define int ll

const double EPS = 1e-6;

using triangle = array<double, 3>;
using pt = array<double, 2>;

double dist2(pt& a, pt& b){
    return (a[0] - b[0]) * (a[0] - b[0]) + (a[1] - b[1]) * (a[1] - b[1]);
}

bool side3(triangle side3_, triangle side2_, triangle side1_, triangle center_){
    bool res = false;
    for (int i = 0; i < 3; ++i) {
        if(side3_[2] == center_[2]){
            triangle rt{side2_[0] + side3_[0], side1_[1] + side3_[1], side1_[2] + side2_[2]};
            pt p0 = {0, 0};
            pt p1 = {rt[1], 0};
            double x = (rt[1] + (rt[2] * rt[2] - rt[0] * rt[0]) / rt[1]) / 2;
            double y = sqrt(rt[2] * rt[2] - x * x);
            pt p2 = {x, y};
            double r2 = side1_[2] / (rt[2]);
            pt pc2 = {p2[0] * r2, p2[1] * r2};
            double r1 = side1_[1] / (rt[1]);
            pt pc1 = {p1[0] * r1, 0};
            double r0 = side3_[0] / (rt[0]);
            pt pc0 = {p1[0] - (p1[0] - p2[0]) * r0, p2[1] * r0};
            bool good = true;
            if(abs(dist2(pc1, pc2) - center_[0] * center_[0]) > EPS)
                good = false;
            if(abs(dist2(pc0, pc2) - center_[1] * center_[1]) > EPS)
                good = false;
            if(abs(dist2(pc0, pc1) - center_[2] * center_[2]) > EPS)
                good = false;
            res |= good;
        }
        rotate(side3_.begin(), side3_.begin() + 1, side3_.end());
    }
    return res;
}

bool side2(array<triangle, 2> t, triangle side1_, triangle center_){
    triangle side2_ = t[0], side3_ = t[1];
    bool res = false;
    for (int i = 0; i < 3; ++i) {
        if(side2_[1] == center_[1]){
            res |= side3(side3_, side2_, side1_, center_);
        }
        rotate(side2_.begin(), side2_.begin() + 1, side2_.end());
    }
    swap(side2_, side3_);
    for (int i = 0; i < 3; ++i) {
        if(side2_[1] == center_[1]){
            res |= side3(side3_, side2_, side1_, center_);
        }
        rotate(side2_.begin(), side2_.begin() + 1, side2_.end());
    }
    return res;
}

bool side1(array<triangle, 3> t, triangle center_){
    array<triangle, 2> t1{t[1], t[2]};
    triangle side1_ = t[0];
    bool res = false;
    for (int i = 0; i < 3; ++i) {
        if(side1_[0] == center_[0]){
            res |= side2(t1, side1_, center_);
        }
        rotate(side1_.begin(), side1_.begin() + 1, side1_.end());
    }
    for (int j = 0; j < 2; ++j) {
        swap(t1[j], side1_);
        for (int i = 0; i < 3; ++i) {
            if(side1_[0] == center_[0]){
                res |= side2(t1, side1_, center_);
            }
            rotate(side1_.begin(), side1_.begin() + 1, side1_.end());
        }
    }
    return res;
}

bool center(array<triangle, 4> t){
    array<triangle, 3> t1{t[1], t[2], t[3]};
    triangle center_ = t[0];
    bool res = side1(t1, center_);
    for (int i = 0; i < 3; ++i) {
        swap(center_, t1[i]);
        res |= side1(t1, center_);
    }
    return res;
}

void solve(){
    int test, n;
    cin >> test >> n;
    vector<triangle> v;
    for (int i = 0; i < n; ++i) {
        pt a, b, c;
        cin >> a[0] >> a[1] >> b[0] >> b[1] >> c[0] >> c[1];
        v.push_back({sqrt(dist2(a, b)), sqrt(dist2(b, c)), sqrt(dist2(c, a))});
    }
    vector<array<int, 4>> ans;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = j + 1; k < n; ++k) {
                for (int l = k + 1; l < n; ++l) {
                    if(center({v[i], v[j], v[k], v[l]}))
                        ans.push_back({i + 1, j + 1, k + 1, l + 1});
                }
            }
        }
    }
    cout << len(ans) << "\n";
    for(auto& t : ans)
        cout << t[0] << " " << t[1] << " " << t[2] << " " << t[3] << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
