#include <bits/stdc++.h>
using namespace std;


using ll = int_fast64_t;

#define len(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define int ll

const ll t1 = 229;
const ll t2 = 227;
const ll mod1 = 1e9 + 7;
const ll mod2 = 1e9 + 7;
vector<ll> t_pow1;
vector<ll> t_pow2;

ll gh(const vector<ll>& h, const vector<ll>& t_pow, const ll mod, int begin, int end){
    return (h[end] - h[begin] * t_pow[end - begin] % mod + mod) % mod;
}
ll ghr(const vector<ll>& hr, const vector<ll>& t_pow, const ll mod, int begin, int end){
    return (hr[begin] - hr[end] * t_pow[end - begin] % mod + mod) % mod;
}

void solve(){
    t_pow1.resize(1e6);
    t_pow1[0] = 1;
    for (int i = 1; i < (int)1e6; ++i) {
        t_pow1[i] = (t_pow1[i - 1] * t1) % mod1;
    }
    t_pow2.resize(1e6);
    t_pow2[0] = 1;
    for (int i = 1; i < (int)1e6; ++i) {
        t_pow2[i] = (t_pow2[i - 1] * t2) % mod2;
    }
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    bool g2 = true;
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
        if(i > 0 && b[i] != b[i - 1])
            g2 = false;
    }
    if(g2){
        vector<ll> h1(n + 1), hr1(n + 1), h2(n + 1), hr2(n + 1);
        for (int i = 1; i < n + 1; ++i) {
            h1[i] = (h1[i - 1] * t1 + a[i - 1]) % mod1;
        }
        for (int i = 1; i < n + 1; ++i) {
            h2[i] = (h2[i - 1] * t2 + a[i - 1]) % mod2;
        }
        for (int i = n - 1; i >= 0; --i) {
            hr1[i] = (hr1[i + 1] * t1 + a[i]) % mod1;
        }
        for (int i = n - 1; i >= 0; --i) {
            hr2[i] = (hr2[i + 1] * t2 + a[i]) % mod2;
        }
        ll ans = 0;
        for (int center = 0; center < n; ++center) {
            int l = 0, r = min(min(center + 1, n - center + 1), m / 2 + 1);
            while(l + 1 < r){
                int md = (l + r) / 2;
                if(gh(h1, t_pow1, mod1, center - md, center) ==
                ghr(hr1, t_pow1, mod1, center + 1, center + md + 1)
                && gh(h2, t_pow2, mod2, center - md, center) ==
                ghr(hr2, t_pow2, mod2, center + 1, center + md + 1))
                    l = md;
                else
                    r = md;
            }
            ans = max(ans, l * 2 + 1);
            l = 0, r = min(min(center + 2, n - center + 1), m / 2 + 1);
            while(l + 1 < r){
                int md = (l + r) / 2;
                if(gh(h1, t_pow1, mod1, center - md + 1, center + 1) ==
                   ghr(hr1, t_pow1, mod1, center + 1, center + md + 1)
                   && gh(h2, t_pow2, mod2, center - md + 1, center + 1) ==
                      ghr(hr2, t_pow2, mod2, center + 1, center + md + 1))
                    l = md;
                else
                    r = md;
            }
            ans = max(ans, l * 2);
        }
        cout << ans << "\n";
        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
